import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
public class TestObjects extends MIDlet implements Runnable{
    Engine eng;
    Display d;
    Thread t;
    Group gr;
    public void startApp(){
        eng=new Engine();
        d=Display.getDisplay(this);
        d.setCurrent((Displayable)eng);
        newObjects();
        t=new Thread(this);
        t.start();
    }
    public static void main(String[]args){
        new TestObjects();
    }
    public void newObjects(){
        Color black=new Color(0,0,0);

        Vektor v1=new Vektor(new Doubleg(100000),new Doubleg(0),new Doubleg(0));
        Vektor v2=new Vektor(new Doubleg(100000),new Doubleg(20000),new Doubleg(0));
        Vektor v3=new Vektor(new Doubleg(100000),new Doubleg(20000),new Doubleg(20000));
        Triangle t1=new Triangle(new Color(20,20,20),black,v1,v2,v3);

        Vektor vy1=new Vektor(new Doubleg(100000),new Doubleg(5000),new Doubleg(5000));
        Vektor vy2=new Vektor(new Doubleg(100000),new Doubleg(15000),new Doubleg(5000));
        Vektor vy3=new Vektor(new Doubleg(100000),new Doubleg(15000),new Doubleg(15000));
        Triangle t2=new Triangle(new Color(40,40,40),black,vy1,vy2,vy3);

        Vektor vx1=new Vektor(new Doubleg(70000),new Doubleg(10000),new Doubleg(10000));
        Vektor vx2=new Vektor(new Doubleg(70000),new Doubleg(15000),new Doubleg(10000));
        Vektor vx3=new Vektor(new Doubleg(70000),new Doubleg(15000),new Doubleg(15000));
        Triangle t3=new Triangle(new Color(60,60,60),black,vx1,vx2,vx3);

        Vektor vb1=new Vektor(new Doubleg(100000),new Doubleg(0),new Doubleg(0));
        Vektor vb2=new Vektor(new Doubleg(95000),new Doubleg(-20000),new Doubleg(0));
        Vektor vb3=new Vektor(new Doubleg(90000),new Doubleg(-20000),new Doubleg(-20000));
        Triangle t4=new Triangle(new Color(80,80,80),black,vb1,vb2,vb3);

        Vektor vc=new Vektor(new Doubleg(80000),new Doubleg(-40000),new Doubleg(-40000));
        Kugel k=new Kugel(new Color(100,100,100),black,vc,new Doubleg(10000));

        PaintGroup pg=new PaintGroup();
        t1.setPaintGroup(pg);
        t2.setPaintGroup(pg);

        gr=new Group();
        gr.add(t1);
        gr.add(t3);
        eng.add(gr);
        eng.add(t2);
        eng.add(t4);
        eng.add(k);
    }
    public void run(){
        try{
            eng.repaint();
            while(true){
                Thread.sleep(100);
                int key=eng.getKey();
//eng.getKey()!=0 => Taste gedrueckt
                if(key!=0){
                    Doubleg up=new Doubleg(250);
//entspricht PI/20
                    Doubleg down=new Doubleg(-250);
//entspricht -PI/20
                    eng.setOff();
//Engine-Display-Update waehrend Transformation ausschalten
                    if(key==-1)eng.rotUp(up);
                    if(key==-2)eng.rotUp(down);
                    if(key==-3)eng.rotLeft(up);
                    if(key==-4)eng.rotLeft(down);
                    if(key==-5)eng.transform(new Doubleg(-7000),new Doubleg(0),new Doubleg(0));
                    eng.setOn();
//Engine-Display-Update anschalten
                    eng.repaint();
                }
            }
        }
        catch(Exception e){
            System.out.println("e: "+e);
        }
    }
    protected void destroyApp(boolean b){
    }
    protected void pauseApp(){
    }
}
